/**
 * Introduction
 *
 * @title ROV - Easy applications from C
 *
 * @copyright Jason Tribbeck / 7th ARM 1994-2001
 *
 * @authors Jason Tribbeck
 *
 * @file drawprintf.c
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "kernel.h"

#ifndef __GNUC__
#pragma -s1
#endif

#include "main.h"
#include "canvas.h"
#include "icons.h"
#include "menu.h"
#include "msg.h"
#include "draw.h"

static icon_data d;
static char draw_printfstring[512];

void draw_printf(int lx, int by, int fcol, int bcol, char * string, ...)
{
  va_list valist;

  va_start(valist, string);
  vsprintf(draw_printfstring, string, valist);
  va_end(valist);

  d.indirecttext.text = draw_printfstring;
  d.indirecttext.valid = (char *) - 1;
  d.indirecttext.length = strlen(draw_printfstring);

  draw_ploticon(lx, by, lx + main_strwidth(draw_printfstring) + 16, by + 32, 0x111 | (fcol << 24) | (bcol << 28), & d);
}

void draw_printff(int lx, int rx, int by, int fcol, int bcol, char * string, ...)
{
  va_list valist;

  va_start(valist, string);
  vsprintf(draw_printfstring, string, valist);
  va_end(valist);

  d.indirecttext.text = draw_printfstring;
  d.indirecttext.valid = (char *) - 1;
  d.indirecttext.length = strlen(draw_printfstring);

  draw_ploticon(lx, by, rx, by + 32, 0x111 | (fcol << 24) | (bcol << 28), & d);
}

void draw_printfb(int lx, int by, int fcol, int bcol, char * string, ...)
{
  va_list valist;

  va_start(valist, string);
  vsprintf(draw_printfstring, string, valist);
  va_end(valist);

  d.indirecttext.text = draw_printfstring;
  d.indirecttext.valid = (char *) - 1;
  d.indirecttext.length = strlen(draw_printfstring);

  draw_ploticon(lx, by, lx + main_strwidth(draw_printfstring) + 16, by + 48, 0x131 | (fcol << 24) | (bcol << 28), & d);
}

void draw_printffb(int lx, int rx, int by, int fcol, int bcol, char * string, ...)
{
  va_list valist;

  va_start(valist, string);
  vsprintf(draw_printfstring, string, valist);
  va_end(valist);

  d.indirecttext.text = draw_printfstring;
  d.indirecttext.valid = (char *) - 1;
  d.indirecttext.length = strlen(draw_printfstring);

  draw_ploticon(lx, by, rx, by + 48, 0x131 | (fcol << 24) | (bcol << 28), & d);
}

